﻿/*
Copyright(c) 2017 株式会社トラスト・ソフトウェア・システム
無断転載を禁止します。
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ImagerApp
{
	public partial class WatermarkStrDlg : Form
	{
		public string textStr;
		public int posX, posY;
		public bool posZ;
		public string fontName;
		public bool fillStr;
		public float fontSize;
		public string fontColor;
		public float alpha;

		//生成
		public WatermarkStrDlg()
		{
			InitializeComponent();

			//初期化
			textStr = "";
			posX = posX = 0;
			posZ = false;
			fontName = "ＭＳ ゴシック";
			fillStr = true;
			fontSize = 10.5f;
			fontColor = "Black";
			alpha = 1.0f;
		}

		private void WatermarkStrDlg_Shown(object sender, EventArgs e)
		{
			strTxt.Text = textStr;
			posXTxt.Text = posX.ToString();
			posYTxt.Text = posY.ToString();
			foregroundRb.Checked = posZ;
			backgroundRb.Checked = !posZ;
			fontNameTxt.Text = fontName;
			fillStrRb.Checked = fillStr;
			fontSizeTxt.Text = fontSize.ToString();
			fontColorTxt.Text = fontColor;
			alphaTxt.Text = (alpha * 100.0f).ToString();
		}

		private void okBtn_Click(object sender, EventArgs e)
		{
			textStr = strTxt.Text;
			posX = int.Parse(posXTxt.Text);
			posY = int.Parse(posYTxt.Text);
			posZ = foregroundRb.Checked;
			fontName = fontNameTxt.Text;
			fillStr = fillStrRb.Checked;
			fontSize = float.Parse(fontSizeTxt.Text);
			fontColor = fontColorTxt.Text;
			alpha = float.Parse(alphaTxt.Text) / 100.0f;
		}
	}
}
