﻿'
' Imager Form Application
'
'Copyright(c)2014-2017株式会社トラスト・ソフトウェア・システム, All Rights Reserved.
'

Imports PDFTools.PdfImagerLP

Public Class Imager
    Private p2i As New PdfImager
    Private pageCount As Integer

    '初期化
    Private Sub InitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InitBtn.Click
        Dim res As Long
        Dim licStr As New System.Text.StringBuilder(70)

        res = p2i.Initialize("0-W0H6-7H5GKW7E336R")     '適切なライセンスキーに替えてください。
        If res <> 0 Then
            MsgBox("PDF Imager-LP 初期化失敗")
            Exit Sub
        End If
        InitBtn.Enabled = False
        UninitBtn.Enabled = True
        p2i.GetLicenseInfoStr(licStr)
        LicStrTxt.Text = licStr.ToString()
        OpenDocBtn.Enabled = True

    End Sub

    'MLP終了
    Private Sub UninitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UninitBtn.Click
        p2i.CloseDoc()
        p2i.Uninitialize()
        OrgSizeXTxt.Text = ""
        OrgSizeYTxt.Text = ""
        LicStrTxt.Text = ""
        InitBtn.Enabled = True
        UninitBtn.Enabled = False
        OpenDocBtn.Enabled = False
        CloseDocBtn.Enabled = False
    End Sub

    '開く
    Private Sub OpenDocBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenDocBtn.Click
        Dim res As Long

        If FileNameTxt.Text = "" Then
            MsgBox("PDFファイルを指定してください")
            Exit Sub
        End If

        res = p2i.OpenDoc(FileNameTxt.Text, "", "")
        Select Case res
            Case err.MLP_NO_ERROR
            Case err.MLP_NOT_INITIALIZED
                MsgBox("初期化されていません")
                Exit Sub
            Case err.MLP_ALREADY_OPENED
                MsgBox("既にオープンしています")
                Exit Sub
            Case err.MLP_FILE_OPEN_ERROR
                MsgBox("オープンできません")
                Exit Sub
            Case err.MLP_FILE_IS_NOT_PDF
                MsgBox("PDFではありません")
                Exit Sub
            Case err.MLP_FILE_NOT_DECRYPTED
                MsgBox("復号できません")
                Exit Sub
        End Select

        '
        OpenDocBtn.Enabled = False
        CloseDocBtn.Enabled = True
        PageToPictBtn.Enabled = True

        'ページリスト
        pageCount = p2i.PageCount()
        If pageCount < 1 Then
            MsgBox("ページがありません")
            PageListTxt.Text = ""
            Exit Sub
        End If
        If PageRangeRB.Checked Then
            PageListTxt.Text = "1-" & pageCount.ToString
        Else
            PageListTxt.Text = "1"
        End If
    End Sub

    'ファイル参照
    Private Sub FileRefBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FileRefBtn.Click
        Dim dlg As New Windows.Forms.OpenFileDialog()

        dlg.Filter = "PDFファイル|*.pdf|すべて|*.*"
        dlg.CheckFileExists = True
        If dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            FileNameTxt.Text = dlg.FileName
        End If
    End Sub

    '画像作成
    Private Sub PageToPictBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PageToPictBtn.Click
        'コールバック設定

        '解像度
        Dim dpi As Integer
        dpi = Val(DpiTxt.Text)
        If dpi < 50 Then dpi = 50
        If dpi > 10000 Then dpi = 10000
        p2i.SetPictureResolution(dpi)

        '品質
        Dim quality As Integer
        quality = Val(QualityTxt.Text)
        If quality < 10 Then quality = 10
        If quality > 90 Then quality = 90
        p2i.SetPictureQuality(quality)

        '色指定
        If ColorRB.Checked Then
            p2i.SetPictureRGB()
        ElseIf GrayRB.Checked Then
            p2i.SetPictureGray()
        ElseIf DitherRB.Checked Then
            p2i.SetPictureDither()
        ElseIf BwRB.Checked Then
            p2i.SetPictureBW()
        End If

        'TIFF圧縮指定
        If CompressNoneRB.Checked Then
            p2i.SetTiffCompress(TiffCompressMode.MLP_TIFF_COMPRESS_NONE)
        ElseIf CompressJpgRB.Checked Then
            p2i.SetTiffCompress(TiffCompressMode.MLP_TIFF_COMPRESS_JPEG)
        ElseIf CompressDeflateRB.Checked Then
            p2i.SetTiffCompress(TiffCompressMode.MLP_TIFF_COMPRESS_DEFLATE)
        ElseIf CompressLzwRB.Checked Then
            p2i.SetTiffCompress(TiffCompressMode.MLP_TIFF_COMPRESS_LZW)
        End If

        'キャンバスサイズ
        Dim cvsx, cvsy As Integer
        cvsx = Val(CvsSizeXTxt.Text)
        cvsy = Val(CvsSizeYTxt.Text)
        If cvsx < 10 Then
            cvsx = 0
            CvsSizeXTxt.Text = ""
        End If
        If cvsy < 10 Then
            cvsy = 0
            CvsSizeYTxt.Text = ""
        End If
        p2i.SetCanvasSize(cvsx, cvsy)

        '画像サイズ
        Dim x, y As Integer
        x = Val(PictSizeXTxt.Text)
        y = Val(PictSizeYTxt.Text)
        If x < 0 Then x = 0
        If y < 0 Then y = 0
        If (0 < x And x < 10) Or (0 < y And y < 10) Then
            MsgBox("画像サイズ x または y が小さすぎます")
            Exit Sub
        End If
        If 10 <= x Or 10 <= y Then
            If UnitPercentRB.Checked Then
                p2i.SetPictureSize(x, y, PictureUnit.MLP_PICTURE_UNIT_PERCENT)
            ElseIf UnitInchRB.Checked Then
                p2i.SetPictureSize(x, y, PictureUnit.MLP_PICTURE_UNIT_INCH)
            ElseIf UnitMmRB.Checked Then
                p2i.SetPictureSize(x, y, PictureUnit.MLP_PICTURE_UNIT_MM)
            Else
                MsgBox("画像サイズの単位を指定してください")
                Exit Sub
            End If
        End If

        '出力ファイル
        Dim out As String
        out = OutputFileTxt.Text
        If out = "" Then
            MsgBox("出力ファイルを指定してください")
            Exit Sub
        End If

        '
        Cursor.Current = Cursors.WaitCursor
        ExitBtn.Enabled = False
        CloseDocBtn.Enabled = False
        PageToPictBtn.Enabled = False

        '画像変換
        If TiffRB.Checked Then
            Dim pageStr As String
            pageStr = PageListTxt.Text
            If p2i.CreateTiffMulti(pageStr, out) <> 0 Then
                MsgBox("画像変換失敗")
                Cursor.Current = Cursors.Default
                ExitBtn.Enabled = True
                CloseDocBtn.Enabled = True
                PageToPictBtn.Enabled = True
                Exit Sub
            End If
        Else
            Dim page As Integer
            page = Val(PageListTxt.Text)
            If p2i.CreatePict(page, out) <> 0 Then
                MsgBox("画像変換失敗")
                Cursor.Current = Cursors.Default
                ExitBtn.Enabled = True
                CloseDocBtn.Enabled = True
                PageToPictBtn.Enabled = True
                Exit Sub
            End If
        End If

        '変換終了
        Cursor.Current = Cursors.Default
        ExitBtn.Enabled = True
        CloseDocBtn.Enabled = True
        PageToPictBtn.Enabled = True
        MsgBox("変換終了")
    End Sub

    '画像フォーマット指定
    Private Sub FormatRB_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TiffRB.CheckedChanged, JpegRB.CheckedChanged, PngRB.CheckedChanged
        Dim ext As String

        ext = "tiff"
        If TiffRB.Checked Then
            ext = "tiff"
            PageRangeRB.Enabled = True
            PageRangeRB.Checked = True
            PageNumRB.Enabled = True
            PageNumRB.Checked = False
            SingleFileChk.Visible = True
            PageListTxt.TextAlign = HorizontalAlignment.Left
            TiffCompressGrp.Enabled = True
        ElseIf JpegRB.Checked Then
            ext = "jpg"
            PageRangeRB.Enabled = False
            PageRangeRB.Checked = False
            PageNumRB.Enabled = False
            PageNumRB.Checked = True
            SingleFileChk.Visible = False
            PageListTxt.TextAlign = HorizontalAlignment.Right
            TiffCompressGrp.Enabled = False
        ElseIf PngRB.Checked Then
            ext = "png"
            PageRangeRB.Enabled = False
            PageRangeRB.Checked = False
            PageNumRB.Enabled = False
            PageNumRB.Checked = True
            SingleFileChk.Visible = False
            PageListTxt.TextAlign = HorizontalAlignment.Right
            TiffCompressGrp.Enabled = False
        End If

        '出力ファイル名
        Dim pos As Integer
        pos = InStrRev(OutputFileTxt.Text, ".")
        If pos = 0 Then : OutputFileTxt.Text = OutputFileTxt.Text & "." & ext
        Else : OutputFileTxt.Text = OutputFileTxt.Text.Substring(0, pos) & ext
        End If
    End Sub

    'ページ範囲・番号指定ラジオボタン
    Private Sub PageRangrNumRB_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PageRangeRB.CheckedChanged, PageNumRB.CheckedChanged
        Dim p As Integer
        If PageRangeRB.Checked Then
            PageSelLbl.Text = "ページ範囲"
            If CloseDocBtn.Enabled And pageCount > 0 Then
                p = Val(PageListTxt.Text)
                If p > 0 And p <= pageCount Then
                    PageListTxt.Text = p.ToString & "-" & pageCount.ToString
                Else
                    PageListTxt.Text = "1-" & pageCount.ToString
                End If
            Else
                PageListTxt.Text = ""
            End If
        End If
        If PageNumRB.Checked Then
            PageSelLbl.Text = "ページ番号"
            If CloseDocBtn.Enabled And pageCount > 0 Then
                p = Val(PageListTxt.Text)
                If p > 0 And p <= pageCount Then
                    PageListTxt.Text = p
                Else
                    PageListTxt.Text = "1"
                End If
            Else
                PageListTxt.Text = ""
            End If
        End If
    End Sub

    'ページ指定が変更された
    Private Sub PageListTxt_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PageListTxt.TextChanged
        If CloseDocBtn.Enabled = False Then Exit Sub
        Dim pgNum As Integer
        pgNum = Val(PageListTxt.Text)
        If pageCount < pgNum Then Exit Sub
        If 0 < pgNum Then
            Dim x, y As Integer
            p2i.SetPictureResolution(72)
            p2i.GetPicturePixel(pgNum, x, y)
            OrgSizeXTxt.Text = x
            OrgSizeYTxt.Text = y
        End If
    End Sub

    '閉じる
    Private Sub CloseDocBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseDocBtn.Click
        p2i.CloseDoc()
        OpenDocBtn.Enabled = True
        CloseDocBtn.Enabled = False
        PageToPictBtn.Enabled = False
        PageListTxt.Text = ""
        OrgSizeXTxt.Text = ""
        OrgSizeYTxt.Text = ""
    End Sub

    'アプリケーション終了
    Private Sub ExitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
        UninitBtn_Click(sender, e)
        End
    End Sub

    'フォーム クローズ
    Private Sub Imager_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        UninitBtn_Click(sender, e)
    End Sub
End Class
